/*
 * lab1.c
 */

#include "lcd.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define F_CPU 16000000
#include <avr/io.h>
#include <util/delay.h>
#include <inttypes.h>                                   /* Include integer type header file */



#include "MPU6050_res_define.h"                         /* Include MPU6050 register define file */
#include "I2C_Master_H_file.h"                          /* Include I2C Master header file */


float Acc_x,Acc_y,Acc_z,Speed,Gyro_x,Gyro_y,Gyro_z;



void MPU6050_Init()                                     /* Gyro initialization function */
{
    //_delay_ms(150);                                     /* Power up time >100ms */
    I2C_Start_Wait(0xD0);                               /* Start with device write address */
    I2C_Write(SMPLRT_DIV);                              /* Write to sample rate register */
    I2C_Write(0x07);                                    /* 1KHz sample rate */
    I2C_Stop();

    I2C_Start_Wait(0xD0);
    I2C_Write(PWR_MGMT_1);                              /* Write to power management register */
    I2C_Write(0x01);                                    /* X axis gyroscope reference frequency */
    I2C_Stop();

    I2C_Start_Wait(0xD0);
    I2C_Write(CONFIG);                                  /* Write to Configuration register */
    I2C_Write(0x00);                                    /* Fs = 8KHz */
    I2C_Stop();

    I2C_Start_Wait(0xD0);
    I2C_Write(GYRO_CONFIG);                             /* Write to Gyro configuration register */
    I2C_Write(0x18);                                    /* Full scale range +/- 2000 degree/C */
    I2C_Stop();

    I2C_Start_Wait(0xD0);
    I2C_Write(INT_ENABLE);                              /* Write to interrupt enable register */
    I2C_Write(0x01);
    I2C_Stop();
}

void MPU_Start_Loc()
{
    I2C_Start_Wait(0xD0);                               /* I2C start with device write address */
    I2C_Write(ACCEL_XOUT_H);                            /* Write start location address from where to read */
    I2C_Repeated_Start(0xD1);                           /* I2C start with device read address */
}

void Read_RawValue()
{
    MPU_Start_Loc();                                    /* Read Gyro values */
    Acc_x = (((int)I2C_Read_Ack()<<8) | (int)I2C_Read_Ack());
    Acc_y = (((int)I2C_Read_Ack()<<8) | (int)I2C_Read_Ack());
    Acc_z = (((int)I2C_Read_Ack()<<8) | (int)I2C_Read_Ack());
    Speed = (((int)I2C_Read_Ack()<<8) | (int)I2C_Read_Ack());
    Gyro_x = (((int)I2C_Read_Ack()<<8) | (int)I2C_Read_Ack());
    Gyro_y = (((int)I2C_Read_Ack()<<8) | (int)I2C_Read_Ack());
    Gyro_z = (((int)I2C_Read_Ack()<<8) | (int)I2C_Read_Nack());
    I2C_Stop();
}


int numarPasi = 0;


void exemplu_lcd()
{

    char buffer[50];
    sprintf(buffer,"Numar pasi %d", numarPasi);
    LCD_print(buffer);

    for(int i = 0 ; i < 100; i ++);
}





int main()
{
    int n = 6;
    DDRD |= (1 << PD7);
    while(n) {
        PORTD ^= (1 << PD7);
        _delay_ms(500);
        n--;
    }



    LCD_init();
    exemplu_lcd();


    float Xa,Ya,Za,t;
    float Xg=0,Yg=0,Zg=0;
    I2C_Init();                                         /* Initialize I2C */

    return 0;
}

